//*********************************************************************
//																	 //
//	SQL Power Injector 1.0 Copyright (c) 2006 Francois Larouche		 //
//																	 //
//  Author	: francois.larouche@sqlpowerinjector.com				 //
//	Web Site: www.sqlpowerinjector.com								 //
//																	 //
//*******************************************************************//
using System;
using System.Windows.Forms;

namespace SQLPowerInjector
{
	/// <summary>
	/// Summary description for InputBox.
	/// </summary>
	internal class InputBox : Form
	{
		#region All variables
		#region Non system variables
		private static InputBox _curBox;
		private static string _inputText = "";
		private static string _title;
		private static string _question;

		public static string Title
		{
			get { return _title; }
			set { _title = value; }
		}
	
		internal static string Question
		{
			get { return _question; }
			set { _question = value; }
		}
		#endregion
		#region Form variables
		private TextBox txtInput;
		private System.Windows.Forms.Label lblQuestion;
		private System.Windows.Forms.Button butCancel;
		private System.Windows.Forms.Button butOK;
		private System.ComponentModel.Container components = null;
		#endregion
		#endregion

		#region Constructor
		private InputBox()
		{
			InitializeComponent();
			_title = (_title != "" && _title != null) ? _title : "InputBox";
			_question = (_question != "" && _question != null) ? _question : "Please insert your input";
		}

		private InputBox(string boxTitle, string boxQuestion)
		{
			InitializeComponent();
			_title = boxTitle;
			_question = boxQuestion;
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(InputBox));
			this.txtInput = new System.Windows.Forms.TextBox();
			this.lblQuestion = new System.Windows.Forms.Label();
			this.butCancel = new System.Windows.Forms.Button();
			this.butOK = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtInput
			// 
			this.txtInput.Location = new System.Drawing.Point(8, 64);
			this.txtInput.Name = "txtInput";
			this.txtInput.Size = new System.Drawing.Size(368, 20);
			this.txtInput.TabIndex = 0;
			this.txtInput.Text = "";
			// 
			// lblQuestion
			// 
			this.lblQuestion.BackColor = System.Drawing.Color.Transparent;
			this.lblQuestion.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblQuestion.ForeColor = System.Drawing.Color.White;
			this.lblQuestion.Location = new System.Drawing.Point(16, 8);
			this.lblQuestion.Name = "lblQuestion";
			this.lblQuestion.Size = new System.Drawing.Size(352, 48);
			this.lblQuestion.TabIndex = 19;
			// 
			// butCancel
			// 
			this.butCancel.BackColor = System.Drawing.Color.LightSlateGray;
			this.butCancel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.butCancel.ForeColor = System.Drawing.Color.White;
			this.butCancel.Location = new System.Drawing.Point(192, 96);
			this.butCancel.Name = "butCancel";
			this.butCancel.Size = new System.Drawing.Size(128, 24);
			this.butCancel.TabIndex = 23;
			this.butCancel.Text = "&Cancel";
			this.butCancel.Click += new System.EventHandler(this.butCancel_Click);
			// 
			// butOK
			// 
			this.butOK.BackColor = System.Drawing.Color.LightSlateGray;
			this.butOK.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.butOK.ForeColor = System.Drawing.Color.White;
			this.butOK.Location = new System.Drawing.Point(56, 96);
			this.butOK.Name = "butOK";
			this.butOK.Size = new System.Drawing.Size(128, 24);
			this.butOK.TabIndex = 22;
			this.butOK.Text = "&OK";
			this.butOK.Click += new System.EventHandler(this.butOK_Click);
			// 
			// InputBox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.RoyalBlue;
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(386, 128);
			this.ControlBox = false;
			this.Controls.Add(this.butCancel);
			this.Controls.Add(this.butOK);
			this.Controls.Add(this.lblQuestion);
			this.Controls.Add(this.txtInput);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "InputBox";
			this.ShowInTaskbar = false;
			this.Text = "InputBox";
			this.ResumeLayout(false);

		}
		#endregion

		// If someone prefers to use the default values or has previously changed  
		// some value directly with the parameters
		public static string ShowInputBox()
		{
			_curBox = new InputBox();
			CreateInputBox();
			_curBox.ShowDialog();

			return _inputText;
		}   
 
		public static string ShowInputBox(string boxTitle, string boxQuestion)
		{
			_curBox = new InputBox(boxTitle, boxQuestion);
			CreateInputBox();
			_curBox.ShowDialog();

			return _inputText;
		}

		private static void CreateInputBox()
		{
			_curBox.Text = _title;
			_curBox.lblQuestion.Text = _question;
		}

		private void butOK_Click(object sender, System.EventArgs e)
		{
			_inputText = this.txtInput.Text;
			this.Close();
		}

		private void butCancel_Click(object sender, System.EventArgs e)
		{
			_inputText = "!!@@!!@@!!@@!!";
			this.Close();
		}
	}
}
